<?php 
class npform
{

//-- ---- ---- ---- ---- ---- ---- ---- ---- ---- ---- ----
// Npform - a simple PHP mailform for any type of forms 
// Copyright: Nekopps (http://www.nekopps.com/) 
// Changes: 2008/10/06 1.0; 2010/12/05 2.0; 
var $name = "Npform"; 
var $version = "2.4b"; 
var $lastmod = "2015/05/06"; 
//-- ---- ---- ---- ---- ---- ---- ---- ---- ---- ---- ----

/*

Simple usege: embed the below on your webpage PHP-runnable

include_once $_SERVER["DOCUMENT_ROOT"]."/__PATH_TO__/npform/lib/npform.class.php"; 
$npform = new npform(); 
//$npform->tooptin = true; // to enable the double opt-in 
$npform->process(); 

*/

	// system variables 
	var $npform = true; 
	var $base; 
	var $home; 
	var $script; 
	var $set; 
	var $put; 
	var $elog; 

	// for application 
	var $in = array(); 
	var $items = array(); 
	var $info = array(); 
	var $mailto = ""; 

	// user configurations
	var $setname; 
	var $setcd = true; 
	var $toadmin = true; 
	var $touser = true; 
	var $tooptin = false; 
	var $allow_nonamehost = true; 
	var $errmsg_sending = "Failed to sending mail"; 
	var $errmsg_notoken = "Your token is not found"; 

	// the others 
	var $detect_order = "UTF-8, SJIS, EUC-JP, JIS"; 

	//-- ---- ---- ---- ---- ---- ---- ---- ---- ---- ---- 
	function npform($params = array())
	{
		$this->base = dirname(dirname(__FILE__)); 
		$this->home = preg_replace('|^\Q'.$_SERVER["DOCUMENT_ROOT"].'\E|', "", $this->base); 
		$this->script = $_SERVER["SCRIPT_NAME"]; 
		$this->set = $this->base."/set"; 
		$this->put = $this->base."/put"; 
		$this->elog = $this->put."/error.log"; 

		ini_set("error_log", $this->elog); 
		ini_set("log_errors", true); 
		ini_set("display_errors", false); 
		error_reporting(E_ALL); 

		if(! extension_loaded("mbstring"))
			trigger_error("Unloaded extension: mbstring"); 

		while(list($key,$val) = each($params))
			$this->prop($key, $val); 

		foreach(array("np", "npforms") as $name)
			if(! class_exists($name)) 
				require $this->base."/lib/$name.class.inc"; 
	}

	//-- ---- ---- ---- ---- ---- ---- ---- ---- ---- --
	function prop($name, $value = null)
	{
		if(isset($value)) 
			$this->$name = $value; 
		return $this->$name; 
	}

	//-- ---- ---- ---- ---- ---- ---- ---- ---- ---- ---- 
	function process($setname = "")
	{
		if(@ $_REQUEST["_version"])
		{
			echo "$this->name ver.$this->version ($this->lastmod)\n"; 
			return; 
		}

		if(! is_writable($this->put))
		{
			echo "(please enable to put data)"; 
			return; 
		}

		$this->setname = $setname; 
		if($cfg = $this->findfile("config.php"))
		{
			$cfg = include $cfg; 
			foreach($cfg as $k => $v)
				$this->prop($k, $v); 
		}

		do
		{
			$this->in = $_POST; 

			if(empty($this->allow_nonamehost))
			{
				$addr = $_SERVER["REMOTE_ADDR"]; 
				$host = gethostbyaddr($addr); 
				if(empty($host) || $host == $addr)
				{
					$this->info[] = "You have no host-name"; 
					trigger_error("No host-name with $addr"); 
					break; 
				}
			}

			np::unicharcode($this->in, "UTF-8"); 
			if(get_magic_quotes_gpc()) 
				$this->in = np::stripslashes_deep($this->in); 
			$this->in = np::unisubmit($this->in, "_"); 

			$token = @ $_GET["_optin"]; 
			if($token)
			{
				foreach(glob($this->put."/*.optin") as $f)
					if(time() > filemtime($f)+60*60*2)
						if(! unlink($f))
							trigger_error("Failed to remove an old token: $f"); 

				$optin = $this->put."/$token.optin"; 
				if(! is_file($optin))
				{
					trigger_error("A token is not found: $optin"); 
					$this->info[] = $this->errmsg_notoken; 
					break; 
				}

				$this->in = unserialize(np::filecont($optin)); 
				if(! unlink($optin))
					trigger_error("Failed to remove a token: $optin"); 
			}

			if(
				empty($this->in) or 
				@ $this->in["_setname"] != $this->setname
			)
				break; 

			$this->items = $this->forminputs($this->in); 
			foreach($this->items as $item)
			{
				if(! isset($this->in[$item["name"]])) 
					$this->in[$item["name"]] = $item["value"]; 
				if($item["email"])
					$this->mailto = $item["value"]; 
			}

			include $this->findfile("errcheck.php"); 
			$errors = errcheck($this->items); 
			$this->info = array_merge($this->info, $errors); 
			if($this->info) 
				break; 

			if(@ $this->in["_confirm"]) 
			{
				include $this->findfile("confirm.php"); 
				return; 
			}

			if(empty($this->in["_send"]))
				break; 

			if($this->tooptin and empty($token))
			{
				do
				{
					$token = md5(microtime()."-".mt_rand()); 
					$optin = $this->put."/$token.optin"; 
				}
				while(is_file($optin)); 
				if(! np::filemake($optin, serialize($_POST)))
				{
					trigger_error("Failed to make a token: $optin"); 
					$this->info[] = "Cannot make a file"; 
					break; 
				}
				$optin_url = np::urlfull()."?_optin=$token"; 

				if($this->touser && $this->mailto)
				{
					ob_start(); 
					include $this->findfile("mail_tooptin.php"); 
					$mail = ob_get_clean(); 
					$mail = "To: $this->mailto\n".$mail; 
					if(! np::sendmail($mail))
					{
						trigger_error("Failed to sending opt-in mail to user"); 
						$this->info[] = $this->errmsg_sending; 
						break; 
					}
				}

				include $this->findfile("optin.php"); 
				return; 
			}

			if($this->toadmin)
			{
				$from = strlen($this->mailto) ? $this->mailto : "none@none.none"; 
				ob_start(); 
				include $this->findfile("mail_toadmin.php"); 
				$mail = ob_get_clean(); 
				$mail = "From: $from\n".$mail; 
				if(! np::sendmail($mail))
				{
					trigger_error("Failed to sending mail to the admin"); 
					$this->info[] = $this->errmsg_sending; 
					break; 
				}
			}

			if($this->touser && $this->mailto)
			{
				ob_start(); 
				include $this->findfile("mail_touser.php"); 
				$mail = ob_get_clean(); 
				$mail = "To: $this->mailto\n".$mail; 
				if(! np::sendmail($mail))
				{
					trigger_error("Failed to sending mail to user"); 
					$this->info[] = $this->errmsg_sending; 
					break; 
				}
			}

			include $this->findfile("thanks.php"); 
			return; 
		}
		while(0); 

		include $this->findfile("form.php"); 
		return; 
	}

	//-- ---- ---- ---- ---- ---- ---- ---- ---- ---- ---- 
	function findfile($fname)
	{
		$dirs = array($this->set); 
		if($this->setcd)
			array_unshift($dirs, "."); 

		foreach($dirs as $dir)
		{
			$fpath = empty($this->setname) ? $fname : "$this->setname/$fname"; 
			do{
				$file = "$dir/$fpath"; 
				//echo "file is: $file\n"; 
				if(file_exists($file))
					return $file; 
				$res = preg_replace('|[^/]*/([^/]+)$|', "$1", $fpath); 
				if(! $res or $res == $fpath)
					break; 
				$fpath = $res; 
			}
			while(true); 
		}
		return; 
	}

	//-- ---- ---- ---- ---- ---- ---- ---- ---- ---- ---- 
	function forminputs($source)
	{
		static $input = array(); 
		if(count($input)) 
			return $input; 

		$cnt = 0; 
		reset($source); 
		while(list($key,$val) = each($source))
		{
			$cnt++; 
			if(substr($key, 0, 1) == "_") 
				continue; 
			preg_match('/^(\*)?(\@)?([0-9]+)?(.*)$/', $key, $m); 
			$label = $name = $m[4]; 
			if(false !== strpos($name, ":"))
				list($label, $name) = explode(":", $name, 2); 
			$elem = array(
				"key"		=> $key, 
				"name"		=> $name, 
				"need"		=> @ $m[1], 
				"email"		=> @ $m[2], 
				"num"		=> (strlen($m[3]) ? intval($m[3]) : $cnt), 
				"label"		=> $label, 
				"value"		=> $val
			); 
			$input[] = $elem; 
		}

		if(! function_exists("_forminputs_sort"))
		{
			function _forminputs_sort($a, $b)
			{ return $a["num"] < $b["num"] ? -1 : ($a["num"] > $b["num"] ? 1 : 0); }
		}
		usort($input, "_forminputs_sort"); 
		return $input; 
	}

	//-- ---- ---- ---- ---- ---- ---- ---- ---- ---- ---- 
	function item($type, $name, $values = "", $default = "", $attrs = null)
	{
		$key = $name; 
		if(false !== strpos($key, ":"))
		{
			list(, $key) = explode(":", $key, 2); 
			$key = preg_replace('/\[\]$/', "", $key); 
		}

		if(! isset($this->in[$key]))
			$this->in[$key] = $default; 

		return npforms::item($type, $name, $values, $this->in[$key], $attrs); 
	}

	//-- ---- ---- ---- ---- ---- ---- ---- ---- ---- ---- 
	function in($name)
	{ return htmlspecialchars(@ $this->in[$name]); }

	//-- ---- ---- ---- ---- ---- ---- ---- ---- ---- ---- 
	function prefectures($head = null)
	{
		$prefs = null; 
		if($file = $this->findfile("prefectures.txt"))
			if($prefs = trim(file_get_contents($file)))
				if($prefs = preg_split('/\s+/', $prefs))
					if($head)
						array_unshift($prefs, $head); 
		return $prefs; 
	}
}
?>
