<p>Npフォームの動作テスト用です。このフォームでは実際にメール送信はされません。</p>

<p>宿泊施設などを想定した予約フォームのサンプルです。ほとんどのフォーム要素を詰め込んでいますので、オリジナルのフォームを作る際に、この内容を切り張りして利用出来ます。</p>

<p>なお、今のところファイル送信には対応していません。</p>

<!-- 
	エラー表示部分：
	・必須項目の未入力、メールアドレスの書式間違いなどを知らせます。
	・基本的にこのまま使って下さい。
-->
<?php include $this->findfile("notice.php"); ?> 

<form action="<?=$this->script?>" method="post">
<input type="hidden" name="_setname" value="<?=$this->setname?>" />

<table style="width: 95%; border: 0; " cellpadding="4" cellspacing="4">
<col style="vertical-align: top; background-color: #ddf; " /><col style="" />

<tr>
<td>お名前：<br />（普通のテキスト）</td>
<td>
	<!-- 
		普通のテキスト：
		・基本的にHTMLでそのまま記述します。valueの指定方法に注意して下さい。
		・nameの前方に * を付けると必須項目となります。
		・nameのコロンを全角で書かないよう気をつけて下さい。
	-->
	<input type="text" name="*お名前:name" value="<?=$this->in('name')?>" placeholder="猫山太郎" size="24" />
</td>
</tr>

<tr>
<td>メールアドレス：<br />（メールアドレスのテキスト）</td>
<td>
	<!-- 
		メールアドレスのテキスト：
		・基本的にHTMLでそのまま記述します。
		・nameの前方に @ を付けるとメールアドレスとして扱われます。
	-->
	<input type="text" name="*@Mailアドレス:email" value="<?=$this->in('email')?>" placeholder="yourname@example.com" size="32" />
</td>
</tr>

<tr>
<td>住所：<br />（テキストとセレクトの複合）</td>
<td>
	<!-- 
		テキストとセレクトの複合：
		・よくある住所入力、このままコピーして使えます。
		・jquery.jpostal.jsを使うと、都道府県と市区町村の自動入力が簡単に実装出来ます。
	-->
	〒<input type="text" name="郵便番号:postcode" id="postcode" value="<?=$this->in('postcode')?>" placeholder="123-4567" size="10" /> ＊郵便番号<br />
	<?php 
		$values = $this->prefectures("都道府県:"); 
		echo $this->item("select", '都道府県:address1', $values, "", array("id" => "address1")); 
	?> 
	<input type="text" name="市区町村:address2" id="address2" value="<?=$this->in('address2')?>" placeholder="○○市○○町" size="16" /> ＊市区町村<br />
	<input type="text" name="番地以下:address3" id="address3" value="<?=$this->in('address3')?>" placeholder="1-2-3 ○○ハイツ 456号室" size="30" /> ＊番地以下
</td>
</tr>
<!--
<script type="text/javascript" src="//code.jquery.com/jquery-1.11.2.min.js"></script>
<script type="text/javascript" src="//jpostal.googlecode.com/svn/trunk/jquery.jpostal.js"></script>
<script type="text/javascript">
$(window).ready(function(){
	// jquery.jpostal.js による住所自動入力機能
	$("#postcode").jpostal({
		postcode: ["#postcode"], 
		address: {"#address1": "%3", "#address2": "%4%5"}
	}); 
}); 
</script>
-->

<tr>
<td>お部屋：<br />（ラジオボタン）</td>
<td>
	<!-- 
		ラジオボタン：
		・PHPコードで記述します。
		・値は半角スペース文字で区切ります。
		・四番目の引数はデフォルトの値です。（'シングル'）
		・日本語を含む文字列はシングルクォートで囲むこと推奨。
	-->
	<?php 
		$values = 'シングル ダブル スイート'; 
		echo implode("\n", $this->item("radio", '*お部屋:room', $values, 'シングル')); 
	?> 
</td>
</tr>

<tr>
<td>お食事：<br />（セレクトメニュー）</td>
<td>
	<!-- 
		セレクトメニュー：
		・PHPコードで記述します。
		・値にコロンがある場合、左側がラベル、右側が実際の値として扱われます。
	-->
	<?php 
		$values = '選択して下さい:0 夕食・朝食付き 夕食のみ 朝食のみ 食事なし'; 
		echo $this->item("select", '*お食事:meal', $values); 
	?> 
</td>
</tr>

<tr>
<td>オプション：<br />（チェックボックス）</td>
<td>
	<!-- 
		チェックボックス：
		・PHPコードで記述します。
		・複数選択項目なので nameの末尾に [] を付けます。（PHPのルール）
		・必須項目とする場合はあらかじめ hiddenを入れて置きます。（[] は付けない）
	-->
	<input type="hidden" name="*オプション:option" value="" />
	<?php 
		$values = 'ネット設備 ジュース類 お酒類 マッサージ'; 
		echo implode("\n", $this->item("checkbox", '*オプション:option[]', $values)); 
	?> 
	<br />＊複数回答可
</td>
</tr>

<tr>
<td>予約日時：<br />（複合的なセレクト）</td>
<td>
	<!-- 
		複合的なセレクトメニュー：
		・よくある年月日指定、このままコピーして使えます。
	-->
	<?php 
		list($y,$m,$d) = explode("/", date("Y/m/d")); 
		$years = range($y-2, $y+2); 
		$months = range(1, 12); 
		$mdays = range(1, 31); 
		array_unshift($years, "-:"); 
		array_unshift($months, "-:"); 
		array_unshift($mdays, "-:"); 
	?>
	<?php echo $this->item("select", '予約年:year', $years, $y); ?>年
	<?php echo $this->item("select", '予約月:month', $months, $m); ?>月
	<?php echo $this->item("select", '予約日:day', $mdays, $d); ?>日
</td>
</tr>

<tr>
<td>備考など：<br />（テキストエリア）</td>
<td>
	<!-- 
		テキストエリア：
		・基本的にHTMLでそのまま記述します。
	-->
	<textarea name="備考など:note" placeholder="眺めの良い部屋を希望します。" cols="10" rows="8" style="width: 90%; "><?=$this->in("note")?></textarea>
</td>
</tr>

<tr style="padding-top: 1em;">
<td>送信ボタン：</td>
<td>
	<!-- 
		送信ボタン：
		・nameには _confirm と指定します。
		・確認画面を挟まない場合は _send として下さい。
	-->
	<input type="submit" name="_confirm" value="入力確認" /> 
	<input type="submit" name="_send" value="送信" /> 
</td>
</tr>

</table>

</form>
